// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nerian_stereo:msg/StereoCameraInfo.idl
// generated code does not contain a copyright notice
#include "nerian_stereo/msg/detail/stereo_camera_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `left_info`
// Member `right_info`
#include "sensor_msgs/msg/detail/camera_info__functions.h"

bool
nerian_stereo__msg__StereoCameraInfo__init(nerian_stereo__msg__StereoCameraInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    nerian_stereo__msg__StereoCameraInfo__fini(msg);
    return false;
  }
  // left_info
  if (!sensor_msgs__msg__CameraInfo__init(&msg->left_info)) {
    nerian_stereo__msg__StereoCameraInfo__fini(msg);
    return false;
  }
  // right_info
  if (!sensor_msgs__msg__CameraInfo__init(&msg->right_info)) {
    nerian_stereo__msg__StereoCameraInfo__fini(msg);
    return false;
  }
  // q
  // t_left_right
  // r_left_right
  return true;
}

void
nerian_stereo__msg__StereoCameraInfo__fini(nerian_stereo__msg__StereoCameraInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // left_info
  sensor_msgs__msg__CameraInfo__fini(&msg->left_info);
  // right_info
  sensor_msgs__msg__CameraInfo__fini(&msg->right_info);
  // q
  // t_left_right
  // r_left_right
}

nerian_stereo__msg__StereoCameraInfo *
nerian_stereo__msg__StereoCameraInfo__create()
{
  nerian_stereo__msg__StereoCameraInfo * msg = (nerian_stereo__msg__StereoCameraInfo *)malloc(sizeof(nerian_stereo__msg__StereoCameraInfo));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nerian_stereo__msg__StereoCameraInfo));
  bool success = nerian_stereo__msg__StereoCameraInfo__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
nerian_stereo__msg__StereoCameraInfo__destroy(nerian_stereo__msg__StereoCameraInfo * msg)
{
  if (msg) {
    nerian_stereo__msg__StereoCameraInfo__fini(msg);
  }
  free(msg);
}


bool
nerian_stereo__msg__StereoCameraInfo__Sequence__init(nerian_stereo__msg__StereoCameraInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  nerian_stereo__msg__StereoCameraInfo * data = NULL;
  if (size) {
    data = (nerian_stereo__msg__StereoCameraInfo *)calloc(size, sizeof(nerian_stereo__msg__StereoCameraInfo));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nerian_stereo__msg__StereoCameraInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nerian_stereo__msg__StereoCameraInfo__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nerian_stereo__msg__StereoCameraInfo__Sequence__fini(nerian_stereo__msg__StereoCameraInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nerian_stereo__msg__StereoCameraInfo__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nerian_stereo__msg__StereoCameraInfo__Sequence *
nerian_stereo__msg__StereoCameraInfo__Sequence__create(size_t size)
{
  nerian_stereo__msg__StereoCameraInfo__Sequence * array = (nerian_stereo__msg__StereoCameraInfo__Sequence *)malloc(sizeof(nerian_stereo__msg__StereoCameraInfo__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = nerian_stereo__msg__StereoCameraInfo__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
nerian_stereo__msg__StereoCameraInfo__Sequence__destroy(nerian_stereo__msg__StereoCameraInfo__Sequence * array)
{
  if (array) {
    nerian_stereo__msg__StereoCameraInfo__Sequence__fini(array);
  }
  free(array);
}
